;---------------------------------------------------------------------------------
; Format integer values with thousand separator.
; Separator symbol and decimal symbol based on NUMBERFMT structure.
;---------------------------------------------------------------------------------
; format_number2.asm
;---------------------------------------------------------------------------------

.nolist
include \masm32\include\masm32rt.inc

.686

.data
    Number      DB  "12345678910.35", 0
    BoxTitle    DB  "Num format Test", 0
    Sep         DB  ",",0
    lpSep       DD  Sep 
    Tsep        DD  ".",0
    lpTsep      DD  Tsep  
  
   
.data?
    Buffer      DB  255 dup(?)
    NumFmt      NUMBERFMT <>
;---------------------------------------------------------------------------------
; Structure for number formatting
;---------------------------------------------------------------------------------   
; NUMBERFMTA STRUCT
;    NumDigits         DWORD      ?
;    LeadingZero       DWORD      ?
;    Grouping          DWORD      ?
;    lpDecimalSep      DWORD      ?
;    lpThousandSep     DWORD      ?
;    NegativeOrder     DWORD      ?
; NUMBERFMTA ENDS
;
; NUMBERFMT  equ  <NUMBERFMTA>     
;---------------------------------------------------------------------------------
.code
start:

    mov NumFmt.NumDigits, 0               ; 0 for No decimal digits
    mov NumFmt.LeadingZero, 0             ; No leading zeroes
    mov NumFmt.Grouping, 3                ; Groups of three numbers
    mov NumFmt.lpDecimalSep,  offset Sep  ; Pointer to NULL terminated string with the decimal separator 
    mov NumFmt.lpThousandSep, offset Tsep ; Pointer to NULL terminated string with the thousand separator
    mov NumFmt.NegativeOrder, 0           ; Negative number mode

    invoke GetNumberFormat, NULL,
                            0,
                            offset Number,
                            offset NumFmt,
                            offset Buffer,
                            255
                           
    invoke MessageBox, NULL,
                       offset Buffer,
                       offset BoxTitle,
                       MB_OK ;  or MB_SYSTEMMODAL 
                     
    invoke ExitProcess, -1
end start
